﻿using System;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Data;

namespace Blog.Models{
    partial class Comment {
        partial void OnTitleChanging(string value) {
            if (!String.IsNullOrEmpty(value) && char.IsDigit(value[0])) {
                throw new Exception("The title should not start with a digit!");
            }
        }

        partial void OnValidate(ChangeAction action) {
            if (action == ChangeAction.Delete)
                return;

            if (Title == null || Body == null)
                return;

            if (Title.Length > Body.Length) {
                throw new Exception("The comment's body must be longer than the title!");
            }
        }
    }
}