﻿<%@ Page Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Title="All items" Inherits="System.Web.Mvc.ViewPage" %>
<%@ Register TagPrefix="mvc" Namespace="System.Web.DynamicData.Controls" Assembly="MVCToolkit" %>
<%@ Import Namespace="Blog.Controllers" %>

<asp:Content ID="Content" ContentPlaceHolderID="MainContentPlaceHolder" runat="server">
    <%= this.RenderUserControl("../Shared/StatusMessage.ascx") %>

    <mvc:DynamicDataHelper ID="dd" runat="server" Entities="Posts,Comments" />
    
    <div>
        <% var post = dd.DataItem;  %>

        <h1><% Post_Title(post); %></h1>

        <p>
        <% Post_Body(post); %>
        </p>
        
        <h2>Comments</h2>

        <%foreach (var comment in post.Comments.OrderBy(c=>c.Timestamp)) {%>
            <div>
                <h4>
                    <span>
                        <% Comment_Title(comment); %>
                    </span>
                </h4>
                <div>
                    Rating: <% Comment_Rating(comment); %>
                </div>
                <div>
                    <% Comment_Timestamp(comment); %>
                </div>
                <% Comment_Body(comment); %>
                
                <div>
                <a href='<%= dd.MakeUrl("destroy", comment, true /*includeReturnPath*/) %>'>Delete</a>
                </div>
            </div>
        <%}%>

        <h2>Add a comment</h2>
        
        <%= this.RenderUserControl("../Shared/ErrorSummary.ascx")%>

        <form method="post" action="<%= dd.MakeUrl("Create", "Comment", new { Post=post }) %>">
            
            <% Comment_Title_Insert(); %><br />
            <% Comment_Body_Insert(); %><br />
            Rating: <% Comment_Rating_Insert(); %><br />
            <%= Html.SubmitButton() %>
        </form>
    </div>
</asp:Content>