﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.Mvc;
using System.Xml.Linq;

namespace System.Web.Mvc {
    public abstract class MembershipControllerBase : Controller {

        [ControllerAction]
        public void Index() {
            RedirectToAction("Login");
        }

        [ControllerAction]
        public void Login() {
            RenderView("Login");
        }

        [ControllerAction]
        public void Logout() {
            FormsAuthentication.SignOut();
            RedirectBackToPreviousPage();
        }

        [ControllerAction]
        public void Authenticate() {
            if (!this.Request.HttpMethod.Equals("post", StringComparison.OrdinalIgnoreCase)) {
                RedirectToAction("Login");
            }

            string user = Request["Username"];
            string password = Request["password"];

            if (Membership.ValidateUser(user, password)) {
                FormsAuthentication.SetAuthCookie(user, false);
                RedirectBackToPreviousPage();
            }
            else {
                // TODO: error handling!
                RedirectToAction("Login");
            }
        }

        private void RedirectBackToPreviousPage() {
            // TODO: implement return URL logic.  For now, just go to the site's root
            Response.Redirect("~");
        }
    }
}
