﻿using System;

namespace Microsoft.Web.DynamicData.Metadata {
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = false)]
    public class MetadataClassAttribute : Attribute {
        public Type MetadataClassType { get; private set; }
        public MetadataClassAttribute(Type metadataClassType) {
            if (metadataClassType == null) {
                throw new ArgumentNullException("metadataClassType");
            }

            MetadataClassType = metadataClassType;
        }
    }
}
