﻿using System;
using System.ComponentModel;

namespace Microsoft.Web.DynamicData.Metadata {

    internal class MetadataTypeDescriptionProvider : TypeDescriptionProvider {
        private MetadataTypeDescriptor _descriptor;
        private IMetadataProvider _metadataProvider;

        public MetadataTypeDescriptionProvider(Type t, IMetadataProvider metadataProvider)
            : base(TypeDescriptor.GetProvider(t)) {
            _metadataProvider = metadataProvider;
        }

        public override ICustomTypeDescriptor GetTypeDescriptor(Type objectType, object instance) {
            if (null == _descriptor) {
                _descriptor = new MetadataTypeDescriptor(_metadataProvider, base.GetTypeDescriptor(objectType, instance));
            }
            return _descriptor;
        }
    }
}
