﻿using System.Collections.Generic;
using System.ComponentModel;

namespace Microsoft.Web.DynamicData.Metadata {
    internal class MetadataTypeDescriptor : CustomTypeDescriptor {
        private IMetadataProvider _metadataProvider;

        public MetadataTypeDescriptor(IMetadataProvider metadataProvider, ICustomTypeDescriptor parent)
            : base(parent) {
            _metadataProvider = metadataProvider;
        }

        public override PropertyDescriptorCollection GetProperties() {
            PropertyDescriptorCollection pdc = new PropertyDescriptorCollection(new PropertyDescriptor[0]);

            foreach (PropertyDescriptor propDescriptor in base.GetProperties()) {
                List<BaseMetadataAttribute> newMetadata = _metadataProvider.GetFieldMetadata(propDescriptor);
                if (newMetadata.Count > 0) {
                    pdc.Add(new MetadataPropertyDescriptorWrapper(propDescriptor, newMetadata.ToArray()));
                }
                else {
                    pdc.Add(propDescriptor);
                }
            }

            return pdc;
        }
    }
}
