﻿using System;
using System.Collections.Generic;
using System.Xml;

namespace Microsoft.Web.DynamicData.Metadata {
    internal static class XmlHelper {
        public static XmlElement GetChildByName(this XmlElement element, string name) {
            XmlElement[] children = element.GetChildrenByName(name);
            if (children.Length == 1)
                return children[0];

            if (children.Length == 0)
                return null;

            throw new InvalidOperationException("More than one child found");
        }

        public static XmlElement[] GetChildrenByName(this XmlElement element, string name) {
            List<XmlElement> children = new List<XmlElement>();
            foreach (XmlNode child in element.ChildNodes) {
                if (child.NodeType == XmlNodeType.Element && child.LocalName.Equals(name, StringComparison.Ordinal))
                    children.Add((XmlElement)child);
            }
            return children.ToArray();
        }
    }
}
